SystemOrganization addCategory: #'CS528-Poker'!
SystemOrganization addCategory: #'CS528-Poker-Cards'!
SystemOrganization addCategory: #'CS528-Poker-Cards-TEST'!
SystemOrganization addCategory: #'CS528-Poker-TEST'!

Error subclass: #PokerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

PokerError subclass: #InvalidAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

PokerError subclass: #NotEnoughChips
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

PokerError subclass: #RaiseTooSmall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

WAComponent subclass: #Card
	instanceVariableNames: 'suit value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Card class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:16'!
newWithSuit: aSuit value: aValue 
	| aCard |
	aCard := Card new suit: aSuit value: aValue.
	^aCard! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:15'!
= aCard
	(aCard isKindOf: Card) ifFalse: [ ^false ].
	(aCard value = value) ifFalse: [ ^false ].
	(aCard suit = suit) ifFalse: [ ^false ].
	^true! !

!Card methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 15:53'!
initialize
	super initialize! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:18'!
printOn: aStream
	value printOn: aStream.
	aStream nextPutAll: ' of '.
	suit printOn: aStream.
	^aStream.! !

!Card methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 21:25'!
renderContentOn: html 
	html div
		class: 'card';
		with: self asString.";
		with: [ 
			html span 
				class: 'suit';	
				with: suit.
				
			html span 
				class: 'rank';
				with: value.
		 ]."! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 09:40'!
shortForm
	^value short, suit short! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:44'!
suit
	^suit! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:17'!
suit: aSuit value: aValue
	suit := aSuit.
	value := aValue.! !

!Card methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:45'!
value
	^value! !

WAComponent subclass: #Hand
	instanceVariableNames: 'cards rank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:37'!
= aHand
	(cards size = aHand cards size) ifFalse: [ ^false ].
	
	cards do: [ :card |
		(aHand cards includes: card) ifFalse: [ ^false ].
	].
	^true! !

!Hand methodsFor: 'adding' stamp: 'PeterIngulli 7/4/2013 11:34'!
add: aCard
	cards add: aCard.! !

!Hand methodsFor: 'adding' stamp: 'PeterIngulli 7/4/2013 11:34'!
addAll: someCards
	cards addAll: someCards.! !

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:13'!
cards
	^cards! !

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:37'!
cards: anArray
	cards := anArray.! !

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:37'!
copy
	| newHand |
	newHand := Hand new.
	newHand cards: self cards copy.
	newHand rank: self rank copy.
	^newHand.! !

!Hand methodsFor: 'initialize-release' stamp: 'PeterIngulli 7/21/2013 14:37'!
initialize
	super initialize.
	cards := OrderedCollection new.
	rank := HandRank new value:0.! !

!Hand methodsFor: 'removing' stamp: 'PeterIngulli 7/21/2013 14:37'!
rank
	^rank! !

!Hand methodsFor: 'removing' stamp: 'PeterIngulli 7/21/2013 14:37'!
rank: aHandRank
	rank := aHandRank! !

!Hand methodsFor: 'removing' stamp: 'PeterIngulli 7/4/2013 11:36'!
remove: aCard
	cards remove: aCard! !

!Hand methodsFor: 'removing' stamp: 'PeterIngulli 7/4/2013 11:36'!
removeAt: anIndex
	cards removeAt: anIndex.! !

!Hand methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 15:52'!
renderContentOn: html 
	html div 
		class: 'cardSet';
		with: [ 
			cards do: [ :card | html render: card ].
		].! !

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:37'!
shortForm
	| str |
	cards isEmptyOrNil ifTrue: [ ^'Empty' ].
	str := ''.
	cards do: [ :card |
		str := str, card shortForm, ', '.
	].
	str := str copyFrom: 1 to: (str size-2).
	^str! !

!Hand methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:26'!
size
	^cards size! !

WAComponent subclass: #Players
	instanceVariableNames: 'players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Players methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 15:07'!
add: aPlayer
	players add: aPlayer! !

!Players methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 22:10'!
at: anIndex
	^ players at: anIndex! !

!Players methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 15:59'!
do: aBlock
	players do: aBlock! !

!Players methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 15:25'!
initialize
	super initialize.
	players := OrderedCollection new.! !

!Players methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/22/2013 23:42'!
renderContentOn: html 
	html div 
		class: 'players';
		with: [ 
			players do: [ :player |
 				html div 
					id: (player name);
					class: 'pokerPlayer';
					class: ( player myTurn ifTrue: ['currentPlayer'] ifFalse: [''] ); 
					class: ( player active ifTrue: [''] ifFalse: ['inactivePlayer'] );
					with: [ 
						html div
							class: 'playerWidget'; 
							with: [  
								html div 
									class: 'playerName';
									with: player name.
		
								html div 
									class: 'playerMoney';
									with: '$', (player bank asString).
								(player hasButton) ifTrue: [ html div class: 'button'; with: 'B'].
							].	
						html div 
							class: 'playerAction';
							with: player lastPlayerAction.
					].
			].
	].
	! !

!Players methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 22:10'!
size
	^ players size! !

TestCase subclass: #CardGameStateTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

CardGameStateTest subclass: #TexasHoldEmStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

TexasHoldEmStateTest subclass: #THBettingRoundTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THBettingRoundTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:31'!
test
	"Not a real test"
	"game := TexasHoldEm new.
	game addPlayers: { 
		TexasHoldEmPlayer new name:'p1'.
		TexasHoldEmPlayer new name:'p2'.
		TexasHoldEmPlayer new name:'p3'.
		TexasHoldEmPlayer new name:'p4'.
		TexasHoldEmPlayer new name:'p5'.
	}.
	
	game play."! !

TexasHoldEmStateTest subclass: #THCollectBlindsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THCollectBlindsTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:32'!
testGoNext
	| player1 player2 player3 player4 |
	
	"given"
	player1 := TexasHoldEmPlayer new.
	player2 := TexasHoldEmPlayer new.
	player3 := TexasHoldEmPlayer new.
	player4 := TexasHoldEmPlayer new.
	game addPlayers: { player1. player2. player3. player4. }.
	game minBet: 10.
	game UI: 'text'.
	
	"when"
	(THCollectBlinds new) goNext: game.
	
	"then"
	self assert: (game pot = 15).
	self assert: (game currentBet = 10).
	self assert: (game currentButton = player1).
	self assert: (game nextPlayer = player4).! !

TexasHoldEmStateTest subclass: #THEvaluateHandsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

TexasHoldEmStateTest subclass: #THFlopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THFlopTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:30'!
testGoNext

	"when"
	(THFlop new) goNext: game.
	
	"then"
	self assert: (game dealer pile size = 1).
	self assert: (game community size = 3).
	self assert: (game state isMemberOf: THBettingRound).
! !

TexasHoldEmStateTest subclass: #THPreFlopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THPreFlopTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:33'!
testGoNext
	| player1 player2 |

	"given"
	player1 := TexasHoldEmPlayer new.
	player2 := TexasHoldEmPlayer new.
	game addPlayers: { player1. player2. }.
	game UI: 'text'.
	
	"when"
	(THPreFlop new) goNext: game.
	
	"then"
	self assert: (player1 hand size = 2).
	self assert: (player2 hand size = 2).
	self assert: (game dealer deck size = 48).
	self assert: (game state isMemberOf: THBettingRound).
! !

TexasHoldEmStateTest subclass: #THRiverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THRiverTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:33'!
testGoNext

	"when"
	(THRiver new) goNext: game.
	
	"then"
	self assert: (game dealer pile size = 1).
	self assert: (game community size = 1).
	self assert: (game state isMemberOf: THBettingRound).
! !

TexasHoldEmStateTest subclass: #THTurnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THTurnTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:33'!
testGoNext

	"when"
	(THRiver new) goNext: game.
	
	"then"
	self assert: (game dealer pile size = 1).
	self assert: (game community size = 1).
	self assert: (game state isMemberOf: THBettingRound).
! !

!TexasHoldEmStateTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:51'!
initialize
	super initialize.
	game := TexasHoldEm new.! !

TestCase subclass: #CardGameTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!CardGameTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:13'!
setUp
	game := CardGame new. ! !

!CardGameTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:14'!
testAddPlayer
	| player1 player2 |
	
	"given"
	player1 := Player new.
	player2 := Player new.
	
	"when"
	game addPlayer: player1.
	game addPlayer: player2.
	
	"then"
	self assert: (game players size = 2).! !

!CardGameTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:13'!
testAddPlayers
	| players |
	
	"given"
	players := OrderedCollection new.
	players add: (Player new).
	players add: (Player new).
	
	"when"
	game addPlayers: players.
	
	"then"
	self assert: (game players size = 2).! !

!CardGameTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:14'!
testMaxPlayers
	
	"when"
	game maxPlayers: 5.
	
	"then"
	self assert: (game maxPlayers = 5).! !

!CardGameTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:14'!
testMinPlayers

	"when"
	game minPlayers: 3.
	
	"then"
	self assert: (game minPlayers = 3).! !

CardGameTest subclass: #TexasHoldEmTest
	instanceVariableNames: 'player1 player2 player3 player4 player5'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!TexasHoldEmTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/11/2013 23:23'!
setUp
	game := TexasHoldEm new.
	player1 := (TexasHoldEmPlayer new name: 'player1').
	player2 := (TexasHoldEmPlayer new name: 'player2').
	player3 := (TexasHoldEmPlayer new name: 'player3').
	player4 := (TexasHoldEmPlayer new name: 'player4').
	player5 := (TexasHoldEmPlayer new name: 'player5').
	game addPlayer: player1.
	game addPlayer: player2.
	game addPlayer: player3.
	game addPlayer: player4.
	game addPlayer: player5.! !

!TexasHoldEmTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/11/2013 23:27'!
testIsBigBlind
	self assert: (game isBigBlind: player3).
	
	game buttonIndex: 4.
	self assert: (game isBigBlind: player1).
	
	game buttonIndex: 5.
	self assert: (game isBigBlind: player2).! !

!TexasHoldEmTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/11/2013 23:26'!
testIsSmallBlind
	self assert: (game isSmallBlind: player2).
	
	game buttonIndex: 5.
	self assert: (game isSmallBlind: player1).! !

TestCase subclass: #CardValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards-TEST'!

!CardValueTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:50'!
testAll
	| allValues |
	allValues := CardValue all.
	
	self assert: (allValues size = 13).
	"These will crash if it fails"
	allValues at: CardValue two label.
	allValues at: CardValue three label.
	allValues at: CardValue four label.
	allValues at: CardValue five label.
	allValues at: CardValue six label.
	allValues at: CardValue seven label.
	allValues at: CardValue eight label.
	allValues at: CardValue nine label.
	allValues at: CardValue ten label.
	allValues at: CardValue jack label.
	allValues at: CardValue queen label.
	allValues at: CardValue king label.
	allValues at: CardValue ace label.! !

!CardValueTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:03'!
testEquality
	"Confirms that each CardValue is equal only to one other CardValue (itself)"
	| allValues value count |
	allValues := CardValue all.
	allValues keys do: [ :key |
		value := allValues at: key.
		count := 0.
		allValues do: [ :val |
			value = val ifTrue: [ count := count+1 ]
		].
		self assert: (count=1)
	]! !

!CardValueTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:10'!
testGreaterThanLessThan
	self assert: (CardValue two < CardValue three).
	self assert: (CardValue two < CardValue four).
	self assert: (CardValue two < CardValue five).
	self assert: (CardValue two < CardValue six).
	self assert: (CardValue two < CardValue seven).
	self assert: (CardValue two < CardValue eight).
	self assert: (CardValue two < CardValue nine).
	self assert: (CardValue two < CardValue ten).
	self assert: (CardValue two < CardValue jack).
	self assert: (CardValue two < CardValue queen).
	self assert: (CardValue two < CardValue king).
	self assert: (CardValue two < CardValue ace).
	
	self assert: (CardValue three > CardValue two).
	self assert: (CardValue three < CardValue four).
	self assert: (CardValue three < CardValue five).
	self assert: (CardValue three < CardValue six).
	self assert: (CardValue three < CardValue seven).
	self assert: (CardValue three < CardValue eight).
	self assert: (CardValue three < CardValue nine).
	self assert: (CardValue three < CardValue ten).
	self assert: (CardValue three < CardValue jack).
	self assert: (CardValue three < CardValue queen).
	self assert: (CardValue three < CardValue king).
	self assert: (CardValue three < CardValue ace).
	
	self assert: (CardValue four > CardValue two).
	self assert: (CardValue four > CardValue three).
	self assert: (CardValue four < CardValue five).
	self assert: (CardValue four < CardValue six).
	self assert: (CardValue four < CardValue seven).
	self assert: (CardValue four < CardValue eight).
	self assert: (CardValue four < CardValue nine).
	self assert: (CardValue four < CardValue ten).
	self assert: (CardValue four < CardValue jack).
	self assert: (CardValue four < CardValue queen).
	self assert: (CardValue four < CardValue king).
	self assert: (CardValue four < CardValue ace).
	
	self assert: (CardValue five > CardValue two).
	self assert: (CardValue five > CardValue three).
	self assert: (CardValue five > CardValue four).
	self assert: (CardValue five < CardValue six).
	self assert: (CardValue five < CardValue seven).
	self assert: (CardValue five < CardValue eight).
	self assert: (CardValue five < CardValue nine).
	self assert: (CardValue five < CardValue ten).
	self assert: (CardValue five < CardValue jack).
	self assert: (CardValue five < CardValue queen).
	self assert: (CardValue five < CardValue king).
	self assert: (CardValue five < CardValue ace).! !

TestCase subclass: #DealerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!DealerTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/9/2013 20:06'!
testDealMultipleTo
	| player dealer originalDeckSize numCards |
	
	numCards := 5.
	player := CardPlayer new.
	dealer := Dealer newWithDeck: (Deck newBasicDeck).
	originalDeckSize := dealer deck size.
	
	dealer deal: numCards to: player.
	
	self assert: ((dealer deck size) = (originalDeckSize - numCards)).
	self assert: ((player hand size) = numCards).! !

!DealerTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/9/2013 20:03'!
testDealMultipleToAll
	| players dealer originalDeckSize numPlayers numCards |
	
	numCards := 2.
	numPlayers := 8.
	players := OrderedCollection new.
	1 to: numPlayers do: [ :num |
		players add: (CardPlayer new)
	].
	dealer := Dealer newWithDeck: (Deck newBasicDeck).
	originalDeckSize := dealer deck size.
	
	dealer deal: numCards toAll: players.
	
	self assert: ((dealer deck size) = (originalDeckSize - (numPlayers * numCards))).
	players do: [ :player |
		self assert: ((player hand size) = numCards).
	].! !

!DealerTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/9/2013 20:05'!
testDealTo
	| player dealer originalDeckSize |
	
	player := CardPlayer new.
	dealer := Dealer newWithDeck: (Deck newBasicDeck).
	originalDeckSize := dealer deck size.
	
	dealer dealTo: player.
	
	self assert: ((dealer deck size) = (originalDeckSize - 1)).
	self assert: ((player hand size) = 1).! !

!DealerTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/9/2013 20:05'!
testDealToAll
	| players dealer originalDeckSize numPlayers |
	
	numPlayers := 8.
	players := OrderedCollection new.
	1 to: numPlayers do: [ :num |
		players add: (CardPlayer new)
	].
	dealer := Dealer newWithDeck: (Deck newBasicDeck).
	originalDeckSize := dealer deck size.
	
	dealer dealToAll: players.
	
	self assert: ((dealer deck size) = (originalDeckSize - (numPlayers))).
	players do: [ :player |
		self assert: ((player hand size) = 1).
	].! !

TestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards-TEST'!

!DeckTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:47'!
testDraw
	| deck size cardShouldBe card |
	deck := Deck newBasicDeck.
	size := deck size.
	cardShouldBe := deck cards at: 1.
	
	card := deck draw.
	self assert: (deck size = (size-1)).
	self assert: (cardShouldBe = card).! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:53'!
testDrawMultiple
	| deck size cardsShouldBe cards numCards |
	deck := Deck newBasicDeck.
	size := deck size.
	numCards := 5.
	cardsShouldBe := deck cards collect: [:a|a] from: 1 to: numCards.
	
	cards := deck draw: numCards.
	self assert: (deck size = (size-numCards)).
	1 to: numCards do: [ :i |
		self assert: ((cards at: i) = (cardsShouldBe at: i))
	]! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:44'!
testNewBasicDeck
	| deck allSuits allValues card |
	deck := Deck newBasicDeck.
	
	allSuits := Suit all.
	allValues := CardValue all.
	
	self assert: ((deck size) = (allSuits size * allValues size)).
	allSuits do: [ :suit |
		allValues do: [ :val |
			card := Card newWithSuit: suit value: val.
			self assert: ((deck cards indexOf: card) > 0).
		]
	]! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:56'!
testSetDeckTo
	| cards deck |
	cards := OrderedCollection new.
	cards add: (Card newWithSuit: (Suit spades) value: (CardValue ace)).
	cards add: (Card newWithSuit: (Suit diamonds) value: (CardValue ace)).
	cards add: (Card newWithSuit: (Suit hearts) value: (CardValue ace)).
	cards add: (Card newWithSuit: (Suit clubs) value: (CardValue ace)).
	
	deck := Deck new.
	deck setDeckTo: cards.
	
	self assert: (deck size = cards size).
	1 to: 4 do: [ :i |
		self assert: ((cards at: i) = (deck cards at: i)).
	]! !

TestCase subclass: #HandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards-TEST'!

!HandTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:26'!
testAdd
	| hand card1 card2 |
	hand := Hand new.
	card1 := (Card newWithSuit: (Suit spades) value: (CardValue four)).
	card2 := (Card newWithSuit: (Suit hearts) value: (CardValue ace)).
	
	hand add: card1.
	self assert: (hand size = 1).
	self assert: ((hand cards at: 1) = card1).
	
	hand add: card2 .
	self assert: (hand size = 2).
	self assert: ((hand cards at: 2) = card2).! !

!HandTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:26'!
testAddAll
	| hand cards card1 card2 card3 |
	hand := Hand new.
	card1 := (Card newWithSuit: (Suit diamonds) value: (CardValue two)).
	card2 := (Card newWithSuit: (Suit hearts) value: (CardValue ace)).
	card3 := (Card newWithSuit: (Suit spades) value: (CardValue four)).
	
	cards := OrderedCollection new.
	cards add: card1; add: card2; add: card3.
	
	hand addAll: cards.
	self assert: (hand size = 3).
	self assert: ((hand cards at: 1) = card1).
	self assert: ((hand cards at: 2) = card2).
	self assert: ((hand cards at: 3) = card3).! !

!HandTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:28'!
testRemove
	| hand card1 card2 |
	hand := Hand new.
	card1 := (Card newWithSuit: (Suit spades) value: (CardValue four)).
	card2 := (Card newWithSuit: (Suit hearts) value: (CardValue ace)).
	
	hand add: card1.
	hand add: card2.
	
	hand remove: card1.
	
	self assert: (hand size = 1).
	self assert: ((hand cards at:1) = card2).! !

!HandTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 12:32'!
testRemoveAt
	| hand card1 card2 card3 |
	hand := Hand new.
	card1 := (Card newWithSuit: (Suit spades) value: (CardValue four)).
	card2 := (Card newWithSuit: (Suit hearts) value: (CardValue ace)).
	card3 := (Card newWithSuit: (Suit diamonds) value: (CardValue ten)).
	
	hand add: card1.
	hand add: card2.
	hand removeAt: 1.
	self assert: (hand size = 1).
	self assert: ((hand cards at:1) = card2).
	
	hand removeAt: 1.
	self assert: (hand size = 0).

	hand add: card1.
	hand add: card2.
	hand removeAt: 2.
	self assert: (hand size = 1).
	self assert: ((hand cards at:1) = card1).
	
	hand removeAt: 1.
	self assert: (hand size = 0).
	
	hand add: card1.
	hand add: card2.
	hand add: card3.
	hand removeAt: 2.
	self assert: (hand size = 2).
	self assert: ((hand cards at:1) = card1).
	self assert: ((hand cards at:2) = card3).! !

TestCase subclass: #PlayerActionFactoryTest
	instanceVariableNames: 'factory params'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

PlayerActionFactoryTest subclass: #THPlayerActionFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 18:59'!
setUp 
	factory := THPlayerActionFactory new.
	params := Dictionary new.! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:00'!
testCreateAllIn
	| action |
	
	"when"
	action := factory create: 'allin' with: params.
	
	"then"
	self assert: (action isMemberOf: AllIn).! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:01'!
testCreateBet
	| action |
	
	"given"
	params at: 'amount' put: 100.
	
	"when"
	action := factory create: 'bet' with: params.
	
	"then"
	self assert: (action isMemberOf: Bet).
	self assert: (action amount = 100).! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:03'!
testCreateCall
	| action |
	
	"given"
	params at: 'amount' put: 100.
	
	"when"
	action := factory create: 'call' with: params.
	
	"then"
	self assert: (action isMemberOf: Call).
	self assert: (action amount = 100).! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:03'!
testCreateCheck
	| action |
	
	"given"
	params at: 'amount' put: 100.
	
	"when"
	action := factory create: 'check' with: params.
	
	"then"
	self assert: (action isMemberOf: Check).
	self assert: (action amount = 100).! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:04'!
testCreateFold
	| action |
	
	"when"
	action := factory create: 'fold' with: params.
	
	"then"
	self assert: (action isMemberOf: Fold).
! !

!THPlayerActionFactoryTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:03'!
testCreateRaise
	| action |
	
	"given"
	params at: 'amount' put: 100.
	
	"when"
	action := factory create: 'raise' with: params.
	
	"then"
	self assert: (action isMemberOf: Raise).
	self assert: (action amount = 100).! !

TestCase subclass: #PlayerTest
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

PlayerTest subclass: #CardPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!CardPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:57'!
setUp 
	player := CardPlayer new.! !

!CardPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:57'!
testAddAllToHand
	| cards deck |
	
	"given"
	deck := Deck newBasicDeck.
	cards := { (deck draw). (deck draw). }.
	
	"when"
	player addAllToHand: cards.
	
	"then"
	self assert: (player hand size = 2).
	! !

!CardPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:59'!
testAddToHand
	| deck |
	
	"given"
	deck := Deck newBasicDeck.
	
	"when"
	player addToHand: (deck draw).
	player addToHand: (deck draw).
	
	"then"
	self assert: (player hand size = 2).
	! !

!CardPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 23:01'!
testRemoveFromHand
	| deck card |
	
	"given"
	deck := Deck newBasicDeck.
	card := (deck draw).
	player addToHand: card.
	
	"when"
	player removeFromHand: card.
	
	"then"
	self assert: (player hand size = 0).
	! !

CardPlayerTest subclass: #PokerPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!PokerPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 23:01'!
setUp 
	player := PokerPlayer new.! !

!PokerPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 23:03'!
testAddToBank

	"given"
	player bank: 500.
	
	"when"
	player addToBank: 1000.
	
	"then"
	self assert: (player bank = 1500).
	! !

!PokerPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 23:03'!
testBank
	
	"when"
	player bank: 500.
	
	"then"
	self assert: (player bank = 500).
	! !

!PokerPlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 23:07'!
testRemoveFromBank

	"given"
	player bank: 500.
	
	"when"
	player removeFromBank: 100.
	
	"then"
	self assert: (player bank = 400).
	! !

!PlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:56'!
setUp 
	player := Player new.! !

!PlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:57'!
testActive
	
	"when"
	player active: false.
	
	"then"
	self assert: (player active = false).! !

!PlayerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 22:57'!
testName

	"when"
	player name: 'john doe'.
	
	"then"
	self assert: (player name = 'john doe').! !

TestCase subclass: #PokerTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-TEST'!

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:16'!
setUp
	game := Poker new. ! !

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:15'!
testAddToPot

	"when"
	game addToPot: 1000.
	game addToPot: 500.
	
	"then"
	self assert: (game pot = 1500).! !

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:41'!
testMaxBet
	
	"when"
	game maxBet: 1000.
	
	"then"
	self assert: (game maxBet = 1000).! !

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:40'!
testMinBet
	
	"when"
	game minBet: 1000.
	
	"then"
	self assert: (game minBet = 1000).! !

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:36'!
testNextButton
	| player1 player2 player3 |
	
	"given"
	player1 := Player new.
	player2 := Player new.
	player3 := Player new.
	game addPlayers: { player1. player2. player3. }.
	
	"when"
	player2 active: false.
	game nextButton.
	game nextButton.
	
	"then"
	self assert: (game currentButton = player1).! !

!PokerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/11/2013 21:39'!
testNextPlayer
	| player1 player2 player3 |
	
	"given"
	player1 := Player new.
	player2 := Player new.
	player3 := Player new.
	game addPlayers: { player1. player2. player3. }.
	
	"when"
	player2 active: false.
	game nextPlayer.
	game nextPlayer.
	
	"then"
	self assert: (game currentPlayer = player1).! !

TestCase subclass: #ShufflerTest
	instanceVariableNames: 'allSuits allValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards-TEST'!

!ShufflerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 21:28'!
setUp
	allSuits := Suit all.
	allValues := CardValue all.! !

!ShufflerTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/9/2013 19:46'!
testFisherYates
	| card deck shuffler |
	"given"
	deck := Deck newBasicDeck.
	shuffler := FisherYates new.
	"when"
	shuffler shuffle: deck.
	"then"
	self assert: ((deck size) = (allSuits size * allValues size)).
	allSuits do: [ :suit |
		allValues do: [ :val |
			card := Card newWithSuit: suit value: val.
			self assert: ((deck cards indexOf: card) > 0).
		]
	].! !

!ShufflerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 21:34'!
testMongean
	| card deck shuffler |
	"given"
	deck := Deck newBasicDeck.
	shuffler := Mongean new.
	"when"
	shuffler shuffle: deck.
	"then"
	self assert: ((deck size) = (allSuits size * allValues size)).
	allSuits do: [ :suit |
		allValues do: [ :val |
			card := Card newWithSuit: suit value: val.
			self assert: ((deck cards indexOf: card) > 0).
		]
	].! !

!ShufflerTest methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 21:34'!
testRiffle
	| card deck shuffler |
	"given"
	deck := Deck newBasicDeck.
	shuffler := Riffle new.
	"when"
	shuffler shuffle: deck.
	"then"
	self assert: ((deck size) = (allSuits size * allValues size)).
	allSuits do: [ :suit |
		allValues do: [ :val |
			card := Card newWithSuit: suit value: val.
			self assert: ((deck cards indexOf: card) > 0).
		]
	].! !

TestCase subclass: #SuitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards-TEST'!

!SuitTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:42'!
testAll
	| allSuits |
	allSuits := Suit all.
	
	self assert: (allSuits size = 4).
	"These will crash if it fails"
	allSuits at: Suit spades label.
	allSuits at: Suit diamonds label.
	allSuits at: Suit hearts label.
	allSuits at: Suit clubs label.! !

!SuitTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:37'!
testEquality
	self assert: (Suit hearts = Suit hearts).
	self assert: (Suit diamonds = Suit diamonds).
	self assert: (Suit clubs = Suit clubs).
	self assert: (Suit spades = Suit spades).
	
	self assert: (Suit hearts == Suit hearts).
	self assert: (Suit diamonds == Suit diamonds).
	self assert: (Suit clubs == Suit clubs).
	self assert: (Suit spades == Suit spades).! !

!SuitTest methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 09:05'!
testInequality
	"hearts"
	self assert: (Suit hearts ~= Suit diamonds).
	self assert: (Suit hearts ~= Suit clubs).
	self assert: (Suit hearts ~= Suit spades).
	"diamonds"
	self assert: (Suit diamonds ~= Suit hearts).
	self assert: (Suit diamonds ~= Suit clubs).
	self assert: (Suit diamonds ~= Suit spades).
	"clubs"
	self assert: (Suit clubs ~= Suit hearts).
	self assert: (Suit clubs ~= Suit diamonds).
	self assert: (Suit clubs ~= Suit spades).
	"spades"
	self assert: (Suit spades ~= Suit hearts).
	self assert: (Suit spades ~= Suit diamonds).
	self assert: (Suit spades ~= Suit clubs).! !

Object subclass: #CardGame
	instanceVariableNames: 'players minPlayers maxPlayers dealer state UI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!CardGame methodsFor: 'accessing' stamp: 'PeterIngulli 7/16/2013 16:56'!
UI
	^UI! !

!CardGame methodsFor: 'accessing' stamp: 'PeterIngulli 7/16/2013 16:56'!
UI: aUIType
	UI := aUIType.! !

!CardGame methodsFor: 'accessing' stamp: 'PeterIngulli 7/12/2013 11:43'!
activePlayers
	| newCol |
	newCol := OrderedCollection new.
	players do: [ :p | p active ifTrue: [ newCol add: p ] ].
	^newCol! !

!CardGame methodsFor: 'modifying' stamp: 'EricSteele 7/11/2013 21:03'!
addPlayer: aPlayer
	players = nil ifTrue: [
		players := OrderedCollection new.
	].
	players add: aPlayer.! !

!CardGame methodsFor: 'modifying' stamp: 'PeterIngulli 7/12/2013 09:32'!
addPlayers: allPlayers
	allPlayers do: [ :player |
		self addPlayer: player.
	].! !

!CardGame methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:12'!
dealer
	^dealer.! !

!CardGame methodsFor: 'modifying' stamp: 'PeterIngulli 7/16/2013 16:46'!
executePlayerAction: anAction
	anAction executeWith: self.! !

!CardGame methodsFor: 'initialization' stamp: 'EricSteele 7/10/2013 19:03'!
initialize
	super initialize.
	minPlayers := 1.
	dealer := Dealer newWithDeck: (Deck newBasicDeck).! !

!CardGame methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:25'!
maxPlayers
	^maxPlayers.! !

!CardGame methodsFor: 'modifying' stamp: 'PeterIngulli 7/9/2013 18:56'!
maxPlayers: aNumber
	maxPlayers := aNumber.! !

!CardGame methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:25'!
minPlayers
	^minPlayers.! !

!CardGame methodsFor: 'modifying' stamp: 'EricSteele 7/10/2013 18:50'!
minPlayers: aNumber
	minPlayers := aNumber.! !

!CardGame methodsFor: 'actions' stamp: 'EricSteele 7/10/2013 18:49'!
play
	^self subclassResponsibility.! !

!CardGame methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:20'!
players
	players = nil ifTrue: [
		players = OrderedCollection new.
	].
	^players.! !

!CardGame methodsFor: 'modifying' stamp: 'PeterIngulli 7/12/2013 01:36'!
setState: aState
	state := aState.! !

!CardGame methodsFor: 'modifying' stamp: 'EricSteele 7/11/2013 22:31'!
state
	^state.! !

CardGame subclass: #Poker
	instanceVariableNames: 'pot minBet maxBet currentBet currentPlayerIndex buttonIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 21:43'!
addToPot: anAmount
	pot := pot + anAmount.! !

!Poker methodsFor: 'player-actions' stamp: 'PeterIngulli 7/12/2013 01:20'!
allin
	
	self currentPlayer madeFirstBet: true.! !

!Poker methodsFor: 'actions' stamp: 'PeterIngulli 7/11/2013 21:49'!
buttonIndex
	^buttonIndex! !

!Poker methodsFor: 'actions' stamp: 'PeterIngulli 7/11/2013 23:26'!
buttonIndex: anIndex
	buttonIndex := anIndex.! !

!Poker methodsFor: 'player-actions' stamp: 'PeterIngulli 7/16/2013 17:11'!
call
	"Player has enough in bank"
	(self currentPlayer bank >= currentBet)
		ifFalse: [ NotEnoughChips signal ].
	
	pot := pot + currentBet - self currentPlayer amountInPot.
	self currentPlayer bet: currentBet.
	
	self currentPlayer madeFirstBet: true.! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:28'!
currentBet
	^currentBet.! !

!Poker methodsFor: 'modifying' stamp: 'EricSteele 7/10/2013 19:28'!
currentBet: anAmount
	currentBet := anAmount.! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/11/2013 21:25'!
currentButton
	^players at: buttonIndex.! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:59'!
currentPlayer
	^players at: currentPlayerIndex.! !

!Poker methodsFor: 'accessing' stamp: 'PeterIngulli 7/12/2013 01:36'!
currentPlayer: anIndex
	currentPlayerIndex := anIndex.! !

!Poker methodsFor: 'accessing' stamp: 'PeterIngulli 7/12/2013 11:36'!
currentPlayerAt: anIndex
	currentPlayerIndex := anIndex.! !

!Poker methodsFor: 'player-actions' stamp: 'PeterIngulli 7/12/2013 11:35'!
fold
	self currentPlayer active: false.! !

!Poker methodsFor: 'accessing' stamp: 'PeterIngulli 7/12/2013 12:23'!
getActionsAvailable
	^self subclassResponsibility! !

!Poker methodsFor: 'initialization' stamp: 'PeterIngulli 7/12/2013 00:34'!
initialize
	super initialize.
	pot := 0.
	minBet := 2.
	maxBet := 100.
	currentBet := 0.
	currentPlayerIndex := 1.
	buttonIndex := 1.
! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:27'!
maxBet
	^maxBet.! !

!Poker methodsFor: 'modifying' stamp: 'EricSteele 7/10/2013 19:27'!
maxBet: anAmount
	maxBet := anAmount.! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:27'!
minBet
	^minBet.! !

!Poker methodsFor: 'modifying' stamp: 'EricSteele 7/10/2013 19:27'!
minBet: anAmount
	minBet := anAmount.! !

!Poker methodsFor: 'modifying' stamp: 'EricSteele 7/11/2013 21:34'!
nextButton
	| nextActivePlayerFound player |
	nextActivePlayerFound := false.
	
	[ nextActivePlayerFound ] whileFalse: [
		buttonIndex := (buttonIndex \\ (players size)) + 1.
		player := players at: buttonIndex.
		nextActivePlayerFound := player active.
	].

	^player.! !

!Poker methodsFor: 'modifying' stamp: 'lb 7/22/2013 19:14'!
nextPlayer
	| nextActivePlayerFound player |
	nextActivePlayerFound := false.

	(players at: currentPlayerIndex) myTurn: false.
	
	[ nextActivePlayerFound ] whileFalse: [
		currentPlayerIndex := (currentPlayerIndex \\ (players size)) + 1.
		player := players at: currentPlayerIndex.
		nextActivePlayerFound := player active.
	].

	player myTurn: true.
	Transcript show: 'MYTURN:', player name.
	^player.! !

!Poker methodsFor: 'modifying' stamp: 'BrianDentino 7/22/2013 22:39'!
nextRound
	self nextButton.
	currentPlayerIndex := buttonIndex.
	pot := 0.
	
	players do: [ :player |
		player amountInPot: 0.
		dealer deck cards addAll: player hand cards.
		player hand: Hand new.
		player active: true.
		player hasButton: false.
	].
	(players at: buttonIndex) hasButton: true.
	
	dealer shuffle.
	dealer deck cards addAll: dealer pile cards.
	dealer pile: Hand new.
	
	"TODO:
	   1. Remove cards from player hands and place them back into the deck.
	  2. Remove cards from community hand and place them back into the deck.
	  3. Remove cards from Dealer's burn pile and place them back into the deck."! !

!Poker methodsFor: 'actions' stamp: 'EricSteele 7/10/2013 18:49'!
play
	^self subclassResponsibility.! !

!Poker methodsFor: 'accessing' stamp: 'EricSteele 7/10/2013 19:26'!
pot
	^pot.! !

!Poker methodsFor: 'player-actions' stamp: 'PeterIngulli 7/12/2013 01:20'!
raise: anAmount
	| bet |
	bet := currentBet + anAmount.
	"Player has enough in bank"
	(self currentPlayer bank >= bet)
		ifFalse: [ NotEnoughChips signal ].
	(anAmount >= currentBet)
		ifFalse: [ RaiseTooSmall signal ].
	
	pot := pot + bet - self currentPlayer amountInPot.
	self currentPlayer bet: bet.
	currentBet := bet.
	
	self currentPlayer madeFirstBet: true.! !

Poker subclass: #TexasHoldEm
	instanceVariableNames: 'community pokerTable playersLeftTillFour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!TexasHoldEm class methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 22:53'!
id: anIdentifier UI: aUI 
	^ TexasHoldEm new id: anIdentifier UI: aUI! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 09:26'!
addPlayer: aPlayer
	super addPlayer: aPlayer.
	aPlayer bank: minBet * 100.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 22:01'!
addPlayer: aPlayerID at: aWebsocket
	
	" this is crappy b/c we don't want websockets here... maybe we can just handle join totally separately and get rid of the handlers completely "
	
	| player |

	player := TexasHoldEmPlayer new name: aPlayerID.
	player bank: minBet * 100.

	players = nil ifTrue: [
		players := Players new.
	].
	players add: player.

	pokerTable addPlayer: player at: aWebsocket.
	pokerTable refreshPlayerList: players.
	
	playersLeftTillFour := playersLeftTillFour - 1.
	playersLeftTillFour  = 0 
		ifTrue: [ self play ].! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 20:54'!
community
	^community.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:20'!
community: aHand
	community := aHand.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 17:12'!
doneBetting
	| player |
	player := players at: currentPlayerIndex.
	player amountInPot = currentBet ifTrue: [
		^player madeFirstBet.
	].
	^false.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:05'!
getActionsAvailable
	| actions |
	actions := ''.
	
	currentBet = 0
		ifTrue: [ actions := actions, ' check bet' ]
		ifFalse: [
			currentBet = self currentPlayer amountInPot ifTrue: [ 
				actions := actions, ' check raise'.
			] ifFalse: [
				actions := actions, ' call raise'
			]
		].
	
	actions := actions, ' fold'.
	actions := actions copyFrom: 2 to: actions size.
	actions := actions, String cr, 'To raise or bet, use "raise|bet <AmountToRaise>"', String cr.
	^actions! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 22:08'!
getAvailableActionsList
	| actions |
	actions := OrderedCollection new.
	
	currentBet = 0
		ifTrue: [ actions add: 'check'; add: 'bet'; add: 'allIn' ]
		ifFalse: [ 
			currentBet = self currentPlayer amountInPot 
				ifTrue: [ actions add: 'check'; add: 'raise'; add: 'allIn' ]
				ifFalse: [ actions add: 'call'; add: 'raise'; add: 'fold'; add: 'allIn' ].
		].
	
	^actions! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 21:49'!
id: anID
	pokerTable := PokerTable id: anID game: self.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 14:59'!
id: anID UI: aUI
	pokerTable := PokerTable id: anID game: self.
	self UI: aUI.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'lb 7/22/2013 18:59'!
initialize
	super initialize.
	maxPlayers := 22.
	community := Hand new.
	playersLeftTillFour := 3."4." "for now, will start the game once 4 players (this equals 0)"! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/11/2013 23:27'!
isBigBlind: aPlayer
	| playerIndex targetIndex |
	playerIndex := players indexOf: aPlayer.
	targetIndex := buttonIndex + 2.
	(targetIndex > players size)
		ifTrue: [ targetIndex := targetIndex - players size ].
	^targetIndex = playerIndex.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/11/2013 23:27'!
isSmallBlind: aPlayer
	| playerIndex targetIndex |
	playerIndex := players indexOf: aPlayer.
	targetIndex := buttonIndex + 1.
	(targetIndex > players size)
		ifTrue: [ targetIndex := targetIndex - players size ].
	^targetIndex = playerIndex.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 12:09'!
nextRound
	super nextRound.
	dealer deck cards addAll: community cards.
	community := Hand new.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/22/2013 22:09'!
play
	self nextRound.
	state := THCollectBlinds new.
	
	"continue playing game until only 1 player remains"
	[[ state ~= THGameEnd ] 
		whileTrue: [ state goNext: self. ]] fork.! !

!TexasHoldEm methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 22:20'!
pokerTable
	^pokerTable! !

Object subclass: #CardGameState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!CardGameState methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 15:29'!
goNext: aCardGame
	^self subclassResponsibility.! !

CardGameState subclass: #TexasHoldEmState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

TexasHoldEmState subclass: #THBettingRound
	instanceVariableNames: 'firstRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THBettingRound methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 23:31'!
goNext: game
	| player |
	
	"Reset all settings related to first run"
	firstRun ifTrue: [
		firstRun := false.
		game players do: [ :p |
			p madeFirstBet: false.
		].
	].
	
	player := game nextPlayer.
	
	game doneBetting ifTrue: [
		game community size caseOf: { 
			[ 0 ] -> [ game setState: THFlop new ].
			[ 3 ] -> [ game setState: THTurn new ].
			[ 4 ] -> [ game setState: THRiver new ].
			[ 5 ] -> [ game setState: THEvaluateHands new ]
		}.
		
		"Reset betting settings (different from first round)
			currentPlayer: button (not small blind)
			currentBet: 0 (not big blind)
			amountInPot: 0 (not blind dependent)"
		game currentPlayerAt: game buttonIndex.
		game currentBet: 0.
		game players do: [ :p |
			p amountInPot: 0.
		]
	] ifFalse: [
		player getAction: game.
	].! !

!THBettingRound methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:30'!
initialize
	firstRun := true.! !

TexasHoldEmState subclass: #THCollectBlinds
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THCollectBlinds methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:32'!
goNext: aCardGame
	| player bigBlind pokerTable |
	
	pokerTable := aCardGame pokerTable.
	bigBlind := aCardGame minBet.
	
	"collect small blind"
	player := aCardGame nextPlayer.
	player bet: (bigBlind / 2).
	aCardGame addToPot: (bigBlind / 2).
	
	"collect big blind"
	player := aCardGame nextPlayer.
	player bet: bigBlind.
	aCardGame addToPot: bigBlind.

	"set current bet to big blind"
	aCardGame currentBet: bigBlind.

	"set next state"
	aCardGame setState: THPreFlop new.
	
	"refresh players"
	aCardGame UI = 'text' ifFalse: [
		pokerTable refreshPlayerList: aCardGame players
	].! !

TexasHoldEmState subclass: #THEvaluateHands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 21:28'!
checkMultiplesHands: aHand
	| histo histoRanks val  |
	histo := Dictionary new.
	aHand cards do: [ :card |
		val := histo at: card value label ifAbsentPut: [ 0 ].
		histo at: card value label put: val+1.
	].
	histoRanks := (histo associations asSortedCollection: [:x :y | x value > y value]) 
            collect: [:assoc | assoc value].
	
	"Four of a kind"
	((histoRanks at: 1) = 4) ifTrue: [
		^aHand rank: FourOfAKind new.
	].
	"Full House or Three of a Kind"
	((histoRanks at: 1) = 3) ifTrue: [
		((histoRanks at: 2) = 2) ifTrue: [
			^aHand rank: FullHouse new.
		] ifFalse: [
			^aHand rank: ThreeOfAKind new.
		]
	].
	"Two Pair or One Pair"
	((histoRanks at: 1) = 2) ifTrue: [
		((histoRanks at: 2) = 2) ifTrue: [
			^aHand rank: TwoPair new.
		] ifFalse: [
			^aHand rank: OnePair new.
		]
	].
	^aHand! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 11:30'!
compareHand: hand1 to: hand2
	| hand |
	hand1 rank = hand2 rank ifTrue: [
		hand := hand2 rank getHigherFrom: hand1 and: hand2.
		(hand=hand1) ifTrue: [ ^1 ].
		(hand=hand2) ifTrue: [ ^-1 ].
		^0.
	].
	(hand1 rank > hand2 rank) ifTrue: [ ^1 ].
	^-1.! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 22:58'!
evaluateHand: aHand
	| tempHand isFlush |
	isFlush := false.
	
	"Pairs, 3ofaKind, 4ofaKind, full house"
	tempHand := self checkMultiplesHands: aHand.
	tempHand rank value = 0 ifFalse: [
		^tempHand.
	].
	
	"Flush check (will resolve after)"
	(self handIsFlush: aHand) ifTrue: [
		isFlush := true
	].

	"Straight / Flush / StraightFlush"
	(self handIsStraight: aHand) ifTrue: [
		isFlush ifTrue: [
			^aHand rank: StraightFlush new.
		] ifFalse: [
			^aHand rank: Straight new.
		]
	] ifFalse: [
		isFlush ifTrue: [
			^aHand rank: Flush new.
		]
	].

	^aHand rank: HighCard new.! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 11:37'!
getBest: aNumber fromHand: aHand
	| bestHand tempHand |
	bestHand := (Hand new rank: (HandRank new value:0)).
	"More than <aNumber> cards total"
	aHand size > aNumber ifTrue: [
		"for each card in the hand"
		aHand cards doWithIndex: [ :card :i |
			"add all but this card to tempHand"
			"(aHand size = 7) ifTrue: [
				self halt.
			]."
			tempHand := Hand new.
			aHand cards from: 1 to: (i-1) do: [ :cardToAdd |
				tempHand add: cardToAdd.
			].
			aHand cards from: (i+1) to: (aHand size) do: [ :cardToAdd |
				tempHand add: cardToAdd.
			].
			"run recursively using hand with 1 card removed"
			tempHand := self getBest: aNumber fromHand: tempHand.
			"if better than current best, set it as bestHand"
			tempHand rank > bestHand rank ifTrue: [
				bestHand := tempHand copy.
			] ifFalse: [
				"compare equal ranks (flush vs flush, etc)"
				tempHand rank = bestHand rank ifTrue: [
					tempHand := self getBestOfEqualHandsFrom: tempHand and: bestHand.
					tempHand isNil ifFalse: [
						bestHand := tempHand.
					]
				]
			]
		].
		^bestHand.
	] ifFalse: [
		self evaluateHand: aHand.
		^aHand.
	].! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 12:12'!
getBestHandsWith: aCardGame
	| hands community allCards bestHand |
	hands := OrderedCollection new.
	aCardGame activePlayers do: [ :p |
		hands add: (p hand copy).
	].
	community := aCardGame community.
	
	hands doWithIndex: [ :hand :i |
		allCards := hand copy.
		allCards cards addAll: community copy cards.
		bestHand := (self getBest: 5 fromHand: allCards).
		hands at: i put: bestHand.
	].
	^hands.! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 23:54'!
getBestOfEqualHandsFrom: hand1 and: hand2
	hand1 rank = hand2 rank ifTrue: [
		^hand2 rank getHigherFrom: hand1 and: hand2.
	]! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 13:24'!
goNext: aCardGame
	| players bestHand bestHands bestIndex temp winner |
	"evaluate player hands and determine the winner"
	bestHand := nil.
	players := aCardGame activePlayers.
	players size = 1 ifTrue: [
		winner := players at: 1.
	] ifFalse: [
		bestHands := (self getBestHandsWith: aCardGame).
		bestHands doWithIndex: [ :hand :i |
			(bestHand isNil) ifTrue: [
				bestHand := hand.
				bestIndex := i.
			] ifFalse: [
				temp := self compareHand: hand to: bestHand.
				(temp = 1) ifTrue: [
					"this hand better"
					bestHand := hand.
					bestIndex := i.
				]
				"Otherwise, either best is better, or they're equal -> use best"
			]
		].
		"All active players would reveal their hands here"
		winner := players at: bestIndex.
	].

	winner addToBank: aCardGame pot.
	UIManager default alert: (winner name), ' has won ', aCardGame pot asString.
	
	"TODO: Check if game is over"
	
	"prepare for next round"
	aCardGame nextRound.
	
	"set next state"
	aCardGame setState: THCollectBlinds new.! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/18/2013 20:58'!
handIsFlush: aHand
	| suit |
	aHand cards do: [ :card |
		suit = nil ifTrue: [ 
			suit := card suit.
		] ifFalse: [ 
			suit = card suit ifFalse: [ ^false ]
		]
	].
	^true! !

!THEvaluateHands methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/18/2013 22:46'!
handIsStraight: aHand
	| sortedValues  |
	sortedValues := aHand cards collect: [ :card | card value ].
	sortedValues := sortedValues sorted: [ :a :b |
		a value < b value
	].
	
	"Is a typical straight (includes Broadway)"
	((sortedValues at:1) value) = ((sortedValues at:5) value-4) ifTrue: [
		^true.
	].

	"The Wheel (A-2-3-4-5)"
	^((sortedValues at:5) = CardValue ace)
		and: ((sortedValues at:4) = CardValue five).! !

TexasHoldEmState subclass: #THFlop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THFlop methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 20:27'!
goNext: aCardGame
	| dealer |
	dealer := aCardGame dealer.
	
	"burn 1 and deal 3 community cards"
	dealer burn: 1.
	dealer deal: 3 toHand: (aCardGame community).
	
	"set next state"
	aCardGame setState: THBettingRound new.
	
	"refresh community cards"
	aCardGame UI = 'text' ifFalse: [
		aCardGame pokerTable refreshCommunity: aCardGame community
	].! !

TexasHoldEmState subclass: #THGameEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

TexasHoldEmState subclass: #THPreFlop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THPreFlop methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:33'!
goNext: aCardGame

	| dealer players pokerTable |
	
	dealer := aCardGame dealer.
	players := aCardGame activePlayers.
	pokerTable := aCardGame pokerTable.
	
	"shuffle deck and give 2 cards to each active player"
	dealer shuffle.
	dealer deal: 2 toAll: players.
	
	"set next state"
	aCardGame setState: THBettingRound new.
	
	"refresh player hands"
	aCardGame UI = 'text' ifFalse: [
		pokerTable refreshHands: players.
	].! !

TexasHoldEmState subclass: #THRiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THRiver methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 20:28'!
goNext: aCardGame
	| dealer |
	dealer := aCardGame dealer.
	
	"burn 1 and deal 1 community card"
	dealer burn: 1.
	dealer deal: 1 toHand: (aCardGame community).
	
	"set next state"
	aCardGame setState: THBettingRound new.
	
	"refresh community cards"
	aCardGame UI = 'text' ifFalse: [
		aCardGame pokerTable refreshCommunity: aCardGame community
	].! !

TexasHoldEmState subclass: #THTurn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THTurn methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 19:50'!
goNext: aCardGame
	| dealer |
	dealer := aCardGame dealer.
	
	"burn 1 and deal 1 community card"
	dealer burn: 1.
	dealer deal: 1 toHand: (aCardGame community).
	
	"set next state"
	aCardGame setState: THBettingRound new.
	
	"refresh community cards"
	aCardGame UI = 'text' ifFalse: [
		aCardGame pokerTable refreshCommunity: aCardGame community
	].! !

!TexasHoldEmState methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 17:56'!
goNext: aCardGame
	^self subclassResponsibility.! !

Object subclass: #CardValue
	instanceVariableNames: 'label value shortLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

CardValue class
	instanceVariableNames: 'values'!

CardValue class
	instanceVariableNames: 'values'!

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:04'!
ace
	values = nil ifTrue: [ self initialize ].
	^values at: #ace! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:05'!
all
	^values! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
eight
	values = nil ifTrue: [ self initialize ].
	^values at: #eight! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
five
	values = nil ifTrue: [ self initialize ].
	^values at: #five! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
four
	values = nil ifTrue: [ self initialize ].
	^values at: #four! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:02'!
initialize
	values := Dictionary new.
	values at: #two put: (CardValue newWithLabel: #two value: 1 short: '2' ).
	values at: #three put: (CardValue newWithLabel: #three value: 2 short: '3' ).
	values at: #four put: (CardValue newWithLabel: #four value: 3 short: '4' ).
	values at: #five put: (CardValue newWithLabel: #five value: 4 short: '5' ).
	values at: #six put: (CardValue newWithLabel: #six value: 5 short: '6' ).
	values at: #seven put: (CardValue newWithLabel: #seven value: 6 short: '7' ).
	values at: #eight put: (CardValue newWithLabel: #eight value: 7 short: '8' ).
	values at: #nine put: (CardValue newWithLabel: #nine value: 8 short: '9' ).
	values at: #ten put: (CardValue newWithLabel: #ten value: 9 short: '10' ).
	values at: #jack put: (CardValue newWithLabel: #jack value: 10 short: 'J' ).
	values at: #queen put: (CardValue newWithLabel: #queen value: 11 short: 'Q' ).
	values at: #king put: (CardValue newWithLabel: #king value: 12 short: 'K' ).
	values at: #ace put: (CardValue newWithLabel: #ace value: 13 short: 'A' ).! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:04'!
jack
	values = nil ifTrue: [ self initialize ].
	^values at: #jack! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:04'!
king
	values = nil ifTrue: [ self initialize ].
	^values at: #king! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:57'!
newWithLabel: aLabel value: aValue 
	^CardValue new label:aLabel value:aValue! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:00'!
newWithLabel: aLabel value: aValue short: aShortLabel
	^CardValue new label:aLabel value:aValue short:aShortLabel! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
nine
	values = nil ifTrue: [ self initialize ].
	^values at: #nine! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:04'!
queen
	values = nil ifTrue: [ self initialize ].
	^values at: #queen! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
seven
	values = nil ifTrue: [ self initialize ].
	^values at: #seven! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
six
	values = nil ifTrue: [ self initialize ].
	^values at: #six! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:04'!
ten
	values = nil ifTrue: [ self initialize ].
	^values at: #ten! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:03'!
three
	values = nil ifTrue: [ self initialize ].
	^values at: #three! !

!CardValue class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:01'!
two
	values = nil ifTrue: [ self initialize ].
	^values at: #two! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:52'!
< aValue
	^value < aValue value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:52'!
<= aValue
	^value <= aValue value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:51'!
= aValue
	^value = aValue value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:51'!
> aValue
	^value > aValue value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:52'!
>= aValue
	^value >= aValue value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:58'!
label
	^label! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:58'!
label: aLabel
	label := aLabel! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:58'!
label: aLabel value: aValue
	label := aLabel.
	value := aValue.! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:00'!
label: aLabel value: aValue short: aShortLabel
	label := aLabel.
	value := aValue.
	shortLabel := aShortLabel.! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:09'!
printOn: aStream
	aStream nextPutAll: label;
		nextPutAll: ' (CardValue)'.
	^aStream! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:02'!
short
	^shortLabel! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:58'!
value
	^value! !

!CardValue methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 10:58'!
value: aValue
	value := aValue! !

Object subclass: #Dealer
	instanceVariableNames: 'deck pile shuffler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Dealer class methodsFor: 'instance-creation' stamp: 'PeterIngulli 7/9/2013 19:12'!
newWithDeck: aDeck
	| aDealer |
	aDealer := Dealer new deck: aDeck.
	^aDealer.! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/21/2013 14:22'!
burn: numberOfCards
	pile addAll: (deck draw: numberOfCards).! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/9/2013 19:24'!
deal: numberOfCards to: aPlayer
	aPlayer addAllToHand: (deck draw: numberOfCards).! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/9/2013 20:03'!
deal: numberOfCards toAll: allPlayers
	1 to: numberOfCards do: [ :number |
		allPlayers do: [ :player |
			player addToHand: (deck draw).
		]
	].! !

!Dealer methodsFor: 'dealing' stamp: 'EricSteele 7/11/2013 22:17'!
deal: numberOfCards toHand: aHand
	aHand addAll: (deck draw: numberOfCards).! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/9/2013 20:04'!
dealTo: aPlayer
	aPlayer addToHand: (deck draw).! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/9/2013 20:02'!
dealToAll: allPlayers
	allPlayers do: [ :player |
		player addToHand: (deck draw).
	]! !

!Dealer methodsFor: 'accessors' stamp: 'PeterIngulli 7/9/2013 19:51'!
deck
	^deck! !

!Dealer methodsFor: 'setters' stamp: 'PeterIngulli 7/9/2013 19:12'!
deck: aDeck
	deck := aDeck.! !

!Dealer methodsFor: 'setters' stamp: 'EricSteele 7/11/2013 22:21'!
initialize
	super initialize.
	pile := Hand new.
	shuffler := FisherYates new.! !

!Dealer methodsFor: 'dealing' stamp: 'EricSteele 7/11/2013 22:07'!
pile
	^pile.! !

!Dealer methodsFor: 'dealing' stamp: 'PeterIngulli 7/12/2013 12:12'!
pile: aHand
	pile := aHand.! !

!Dealer methodsFor: 'accessors' stamp: 'PeterIngulli 7/9/2013 19:38'!
shuffle
	shuffler shuffle: deck.! !

!Dealer methodsFor: 'setters' stamp: 'PeterIngulli 7/9/2013 19:38'!
shuffler: aShuffler
	shuffler := aShuffler! !

Object subclass: #Deck
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Deck class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:21'!
newBasicDeck
	| aDeck cards |
	aDeck := Deck new.
	cards := OrderedCollection new.
	
	Suit all do: [ :suit |
		CardValue all do: [ :val |
			cards add: (Card newWithSuit: suit value: val).
		]
	].

	aDeck setDeckTo: cards.
	
	^aDeck! !

!Deck methodsFor: 'accessing' stamp: 'EricSteele 7/6/2013 13:48'!
at: index
	^cards at: index.! !

!Deck methodsFor: 'modifying' stamp: 'EricSteele 7/6/2013 13:50'!
at: index put: card
	^cards at: index put: card.! !

!Deck methodsFor: 'accessing' stamp: 'PeterIngulli 7/4/2013 12:36'!
cards
	^cards! !

!Deck methodsFor: 'modifying' stamp: 'PeterIngulli 7/4/2013 11:30'!
draw
	^cards removeFirst! !

!Deck methodsFor: 'modifying' stamp: 'PeterIngulli 7/4/2013 12:53'!
draw: numCards
	^cards removeFirst: numCards.! !

!Deck methodsFor: 'modifying' stamp: 'EricSteele 7/6/2013 13:24'!
removeAt: index
	| removed |
	removed := cards removeAt: index.
	^removed! !

!Deck methodsFor: 'modifying' stamp: 'PeterIngulli 7/4/2013 11:23'!
setDeckTo: someCards
	cards := someCards.! !

!Deck methodsFor: 'accessing' stamp: 'PeterIngulli 7/4/2013 12:44'!
size
	^cards size.! !

!Deck methodsFor: 'modifying' stamp: 'EricSteele 7/6/2013 13:55'!
swap: index1 with: index2
	| temp |
	temp := cards at: index1.
	cards at: index1 put: (cards at: index2).
	cards at: index2 put: temp.! !

Object subclass: #HandRank
	instanceVariableNames: 'value label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

HandRank subclass: #Flush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Flush methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 19:33'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	"For each card - if 1 is higher, that hand wins"
	1 to: hand1 cards size do: [ :i |
		card1 := sorted1 at: i.
		card2 := sorted2 at: i.
		(card1 value > card2 value) ifTrue: [
			^hand1.
		] ifFalse: [
			(card1 value < card2 value) ifTrue: [
				^hand2.
			]
		]
	].
	"Hands are equal!!"
	^nil.! !

!Flush methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:39'!
initialize 
	label := 'flush'.
	value := 6.! !

HandRank subclass: #FourOfAKind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!FourOfAKind methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 12:26'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	"Four of a kind - if 1=2, the four are 1-4, otherwise 2-5"
	((sorted1 at: 1) = (sorted1 at:2)) ifTrue: [
		card1 := sorted1 at:1.
	] ifFalse: [
		card1 := sorted1 at:2.
	].
	
	((sorted2 at:1) = (sorted2 at:2)) ifTrue: [
		card2 := sorted2 at:1.
	] ifFalse: [
		card2 := sorted2 at:2.
	].

	(card1 value > card2 value) ifTrue: [
		^hand1.
	].
	^hand2.! !

!FourOfAKind methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:40'!
initialize 
	label := 'fourOfAKind'.
	value := 8.! !

HandRank subclass: #FullHouse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!FullHouse methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 22:03'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	"Full House - if 1=3, the three are 1-3, otherwise 3-5"
	((sorted1 at: 1) = (sorted1 at:3)) ifTrue: [
		card1 := sorted1 at:1.
	] ifFalse: [
		card1 := sorted1 at:3.
	].
	
	((sorted2 at:1) = (sorted2 at:3)) ifTrue: [
		card2 := sorted2 at:1.
	] ifFalse: [
		card2 := sorted2 at:3.
	].

	(card1 value > card2 value) ifTrue: [
		^hand1.
	].
	^hand2.
	
	"Full House can never be equal."! !

!FullHouse methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:40'!
initialize 
	label := 'fullHouse'.
	value := 7.! !

!HandRank class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:50'!
newWithValue: aValue label: aLabel
	| retVal |
	retVal := HandRank new.
	retVal value: aValue.
	retVal label: aLabel.
	^retVal! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:45'!
< aRank
	(value = aRank value) ifTrue: [
		
	].
	^value < aRank value.! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:33'!
<= aRank
	^(self > aRank) not! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:59'!
= aRank
	^value = aRank value! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:32'!
> aRank
	^aRank < self! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:32'!
>= aRank
	^aRank <= self! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:58'!
getHigherFrom: hand1 and: hand2
	(hand1 rank > hand2 rank) ifTrue: [
		^hand1.
	].
	^hand2.! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:50'!
label
	^label! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:50'!
label: aLabel
	label := aLabel.! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:50'!
value
	^value! !

!HandRank methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/17/2013 19:50'!
value: aValue
	value := aValue.! !

HandRank subclass: #HighCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!HighCard methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 21:29'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	((sorted1 at: 1) value > (sorted2 at:1) value) ifTrue: [
		^hand1
	] ifFalse: [
		((sorted1 at: 1) value = (sorted2 at:1) value) ifTrue: [
			^nil
		].
		^hand2
	].! !

!HighCard methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:39'!
initialize 
	label := 'highCard'.
	value := 1.! !

HandRank subclass: #OnePair
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!OnePair methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 12:49'!
getHighCardsFrom: aList wherePairIs: aCard
	| newList toRemove |
	toRemove := Bag new.
	newList := aList asBag.
	newList do: [ :card |
		(card value = aCard value) ifTrue: [
			toRemove add: card.
		]
	].
	toRemove do: [ :card | newList remove: card ].
	^newList asSortedCollection: [ :a :b | a value > b value ].! !

!OnePair methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 12:51'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	1 to: sorted1 size-1 do: [ :i |
		((sorted1 at: i) value = (sorted1 at:i+1) value) ifTrue: [
			card1 := sorted1 at:i.
		].
		((sorted2 at: i) value = (sorted2 at:i+1) value) ifTrue: [
			card2 := sorted2 at:i.
		]
	].
	
	(card1 value > card2 value) ifTrue: [
		^hand1
	] ifFalse: [
		(card1 value = card2 value) ifTrue: [
			"Return based on high card"
			sorted1 := self getHighCardsFrom: sorted1 wherePairIs: card1.
			sorted2 := self getHighCardsFrom: sorted2 wherePairIs: card2.
			sorted1 doWithIndex: [ :card :i |
				(card value > (sorted2 at:i) value) ifTrue: [ ^hand1 ].
				(card value < (sorted2 at:i) value) ifTrue: [ ^hand2 ].
			].
			^nil.
		].
		^hand2
	].! !

!OnePair methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:39'!
initialize 
	label := 'onePair'.
	value := 2.! !

OnePair subclass: #TwoPair
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!TwoPair methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 14:27'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 highPair1 lowPair1 highPair2 lowPair2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	((sorted1 at: 1) value = (sorted1 at: 2) value) ifTrue: [
		highPair1 := sorted1 at: 1.
		((sorted1 at: 3) value = (sorted1 at: 4) value)
			ifTrue: [
				lowPair1 := sorted1 at: 3.
				card1 := sorted1 at: 5.
			] ifFalse: [
				lowPair1 := sorted1 at: 4.
				card1 := sorted1 at: 3.
			]
	] ifFalse: [
		highPair1 := sorted1 at: 2.
		lowPair1 := sorted1 at: 4.
		card1 := sorted1 at: 1.
	].

	((sorted2 at: 1) value = (sorted2 at: 2) value) ifTrue: [
		highPair2 := sorted2 at: 1.
		((sorted2 at: 3) value = (sorted2 at: 4) value)
			ifTrue: [
				lowPair2 := sorted2 at: 3.
				card2 := sorted2 at: 5.
			] ifFalse: [
				lowPair2 := sorted2 at: 4.
				card2 := sorted2 at: 3.
			]
	] ifFalse: [
		highPair2 := sorted2 at: 2.
		lowPair2 := sorted2 at: 4.
		card2 := sorted2 at: 1.
	].
	
	"Check high pairs"
	(highPair1 value > highPair2 value) ifTrue: [
		"highPair1 > highPair2 -> hand1"
		^hand1
	] ifFalse: [
		(highPair1 value = highPair2 value) ifTrue: [
		""	"highPair1 = highPair2 -> check low pairs"
			(lowPair1 value > lowPair2 value) ifTrue: [
		""		"lowPair1 > lowPair2 -> hand1"
				^hand1.
		""	] ifFalse: [
				(lowPair1 value = lowPair2 value) ifTrue: [
		""		""	"lowPair1 = lowPair2 -> check high cards"
					(card1 value > card2 value) ifTrue: [
		""		""		"hand1 has better high card"
						^hand1.
		""		""	] ifFalse: [
						(card1 value = card2 value) ifTrue: [
		""		""			"Same pairs, same high card"
							^nil.
		""		""		].
						"hand2 has better high card"
		""		""		^hand2.
					]
		""		].
				"hand2 has better low pair"
		""		^hand2.
			]
		].
		"hand2 has better high pair"
		^hand2
	].! !

!TwoPair methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:40'!
initialize 
	label := 'twoPair'.
	value := 3.! !

HandRank subclass: #Straight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Straight methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 21:54'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	"hand1 is a Wheel"
	(((sorted1 at:1) value = CardValue ace)
	   and: ((sorted1 at:2) value = CardValue two)) ifTrue: [
		((sorted1 at:2) value > (sorted2 at:1) value) ifTrue: [
			^hand1.
		] ifFalse: [
			((sorted1 at:2) value = (sorted2 at:1) value) ifTrue: [
				^nil
			].
			^hand2.
		]
	].
	"hand2  is a Wheel"
	(((sorted2 at:1) value = CardValue ace)
	   and: ((sorted2 at:2) value = CardValue two)) ifTrue: [
		((sorted2 at:2) value > (sorted1 at:1) value) ifTrue: [
			^hand2.
		] ifFalse: [
			((sorted2 at:2) value = (sorted1 at:1) value) ifTrue: [
				^nil
			].
			^hand1.
		]
	].
	"Neither are Wheels, this is actually super simple"
	((sorted1 at:1) value > (sorted2 at:1) value) ifTrue: [
		^hand1
	] ifFalse: [
		((sorted1 at:1) value = (sorted2 at:1) value) ifTrue: [
			^nil
		].
		^hand2
	]! !

!Straight methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 22:54'!
initialize 
	label := 'straight'.
	value := 5.! !

Straight subclass: #StraightFlush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!StraightFlush methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:41'!
initialize 
	label := 'straightFlush'.
	value := 9.! !

HandRank subclass: #ThreeOfAKind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!ThreeOfAKind methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/20/2013 13:29'!
getHigherFrom: hand1 and: hand2
	| sorted1 sorted2 card1 card2 |
	(hand1 rank = hand2 rank) ifFalse: [
		^super getHigherFrom: hand1 and: hand2.
	].

	sorted1 := hand1 cards asSortedCollection: [ :x :y | x value > y value ].
	sorted2 := hand2 cards asSortedCollection: [ :x :y | x value > y value ].
	
	"3OfAKind - if 1=3, the three are 1-3, otherwise 3-5"
	((sorted1 at: 1) = (sorted1 at:3)) ifTrue: [
		card1 := sorted1 at:1.
	] ifFalse: [
		card1 := sorted1 at:3.
	].
	
	((sorted2 at:1) = (sorted2 at:3)) ifTrue: [
		card2 := sorted2 at:1.
	] ifFalse: [
		card2 := sorted2 at:3.
	].

	(card1 value > card2 value) ifTrue: [
		^hand1.
	].
	^hand2
	
	"Three of a kind can never be equal."! !

!ThreeOfAKind methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/19/2013 18:40'!
initialize 
	label := 'threeOfAKind'.
	value := 4.! !

Object subclass: #Player
	instanceVariableNames: 'name active myTurn hasButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

Player subclass: #CardPlayer
	instanceVariableNames: 'hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!CardPlayer methodsFor: 'handChanges' stamp: 'PeterIngulli 7/9/2013 19:23'!
addAllToHand: allCards
	hand addAll: allCards! !

!CardPlayer methodsFor: 'handChanges' stamp: 'PeterIngulli 7/9/2013 17:32'!
addToHand: aCard
	hand add: aCard! !

!CardPlayer methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 21:26'!
getAction: aCardGame
	^self subclassResponsibility.! !

!CardPlayer methodsFor: 'handChanges' stamp: 'PeterIngulli 7/9/2013 19:51'!
hand
	^hand! !

!CardPlayer methodsFor: 'handChanges' stamp: 'PeterIngulli 7/12/2013 11:53'!
hand: aHand 
	hand := aHand.! !

!CardPlayer methodsFor: 'initialize-release' stamp: 'PeterIngulli 7/9/2013 17:38'!
initialize
	super initialize.
	hand := Hand new.! !

!CardPlayer methodsFor: 'handChanges' stamp: 'PeterIngulli 7/9/2013 17:33'!
removeFromHand: aCard
	hand remove: aCard.! !

CardPlayer subclass: #PokerPlayer
	instanceVariableNames: 'bank amountInPot lastPlayerAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!PokerPlayer commentStamp: '<historical>' prior: 0!
A PokerPlayer is a Seaside component that manages client decisions. When the state of a game changes, the PokerPlayer class notifies the view via a websocket connection to the browser.

Instance Variables
!

!PokerPlayer class methodsFor: 'initialize' stamp: 'BrianDentino 7/12/2013 02:13'!
initialize 
	super initialize.
	nextID := 0.! !

!PokerPlayer class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/12/2013 02:17'!
nextID
	nextID := nextID + 1.
	^ nextID asString.! !

!PokerPlayer class methodsFor: 'initialize' stamp: 'BrianDentino 7/12/2013 02:15'!
tableID: table
	^(self new tableID: table playerID: PokerPlayer nextID)! !

!PokerPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/9/2013 18:52'!
addToBank: anAmount
	bank := bank + anAmount! !

!PokerPlayer methodsFor: 'actions' stamp: 'PeterIngulli 7/11/2013 22:31'!
amountInPot
	^amountInPot! !

!PokerPlayer methodsFor: 'actions' stamp: 'PeterIngulli 7/12/2013 00:31'!
amountInPot: anAmount
	amountInPot := anAmount.! !

!PokerPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/9/2013 22:00'!
bank
	^bank! !

!PokerPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/11/2013 23:05'!
bank: aNumber
	bank := aNumber.! !

!PokerPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/12/2013 00:45'!
bet: anAmount
	| difference |
	difference := anAmount - amountInPot.
	bank := bank - difference.
	amountInPot := anAmount.! !

!PokerPlayer methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 01:47'!
close
	table close.! !

!PokerPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/14/2013 14:52'!
draw

	| msg |
	msg := WebsocketMessage id: 'Draw' content: ''.
	table sendMessage: msg json! !

!PokerPlayer methodsFor: 'actions' stamp: 'EricSteele 7/10/2013 21:26'!
getAction: aCardGame
	^self subclassResponsibility.! !

!PokerPlayer methodsFor: 'initialize-release' stamp: 'lb 7/21/2013 17:13'!
initialize
	super initialize.
	bank := 0.
	amountInPot := 0.
	lastPlayerAction := nil.! !

!PokerPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 17:16'!
lastPlayerAction

	^ lastPlayerAction! !

!PokerPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 17:09'!
lastPlayerAction: aPlayerAction

	lastPlayerAction := aPlayerAction! !

!PokerPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/9/2013 18:53'!
removeFromBank: anAmount
	bank := bank - anAmount! !

PokerPlayer subclass: #TexasHoldEmPlayer
	instanceVariableNames: 'madeFirstBet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!TexasHoldEmPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/21/2013 16:59'!
getAction: aGame

	aGame UI = 'text' ifTrue: [
		"use UIManager"
		self getActionFromUI: aGame.
	] ifFalse: [
		"use Seaside"
		self getActionFromSeaside: aGame.
	]! !

!TexasHoldEmPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/22/2013 19:33'!
getActionFromSeaside: aGame
	| action |
	
	aGame pokerTable getPlayerAction: (aGame currentPlayer) availableActions: (aGame getAvailableActionsList).
	
	"refresh players to show the correct player's turn"
	aGame UI = 'text' ifFalse: [
		aGame pokerTable refreshPlayerList: aGame players.
	].
		
	aGame pokerTable waitingForResponse: true.
	[ aGame pokerTable waitingForResponse ] 
		whileTrue: [ (Delay forMilliseconds: 500) wait. ].
	
	action := aGame pokerTable lastPlayerAction.
	
	aGame currentPlayer lastPlayerAction: action.
	aGame executePlayerAction: action.
	
	"refresh players to show last play"
	aGame UI = 'text' ifFalse: [
		aGame pokerTable refreshPlayerList: aGame players.
	].! !

!TexasHoldEmPlayer methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/21/2013 14:27'!
getActionFromUI: aGame
	| response str action |
	str := 'Pot: ', aGame pot asString, String cr, String cr.
	str := str, name, String cr.
	str := str, 'Current Bet: ', aGame currentBet asString
	              , ' | To call, add: ', (aGame currentBet - amountInPot) asString, String cr
	              , 'Actions available: ', aGame getActionsAvailable.
	
	str := str, String cr, 'Community: ', aGame community shortForm, String cr
	              , 'Your Cards: ', hand shortForm.
	str findTokens: String cr.
	
	response := UIManager default request: str.
	response := response subStrings: ' '.
	(response at: 1) caseOf: {
		[ 'call' ] -> [ action := Call new ].
		[ 'check' ] -> [ action := Call new ].
		[ 'bet' ] -> [ action := Raise newWith: ((response at: 2) asInteger) ].
		[ 'raise' ] -> [ action := Raise newWith: ((response at: 2) asInteger) ].
		[ 'fold' ] -> [ action := Fold new ].
		[ 'all' ] -> [ action := AllIn new ].
	} otherwise: [
		InvalidAction signal.
	].
	
	aGame executePlayerAction: action.! !

!TexasHoldEmPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/12/2013 01:21'!
initialize
	super initialize.
	madeFirstBet := false.! !

!TexasHoldEmPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/12/2013 01:18'!
madeFirstBet
	^madeFirstBet! !

!TexasHoldEmPlayer methodsFor: 'bankChanges' stamp: 'PeterIngulli 7/12/2013 01:18'!
madeFirstBet: aBoolean
	madeFirstBet := aBoolean! !

!Player methodsFor: 'accessors' stamp: 'PeterIngulli 7/9/2013 17:31'!
active
	^active! !

!Player methodsFor: 'setters' stamp: 'PeterIngulli 7/9/2013 17:31'!
active: isActive
	active := isActive.! !

!Player methodsFor: 'setters' stamp: 'PeterIngulli 7/12/2013 09:39'!
getAction: context
	^self subclassResponsibility.! !

!Player methodsFor: 'accessors' stamp: 'BrianDentino 7/22/2013 21:41'!
hasButton
	^hasButton! !

!Player methodsFor: 'setters' stamp: 'BrianDentino 7/22/2013 21:42'!
hasButton: aBoolean
	hasButton := aBoolean.! !

!Player methodsFor: 'initialize-release' stamp: 'BrianDentino 7/22/2013 21:42'!
initialize
	super initialize.
	name := ''.
	active := true.
	myTurn := false.
	hasButton := false.! !

!Player methodsFor: 'accessors' stamp: 'lb 7/21/2013 17:22'!
myTurn
	^ myTurn! !

!Player methodsFor: 'setters' stamp: 'lb 7/21/2013 17:22'!
myTurn: aBoolean
	myTurn := aBoolean! !

!Player methodsFor: 'accessors' stamp: 'lb 7/19/2013 16:12'!
name
	^name! !

!Player methodsFor: 'setters' stamp: 'lb 7/19/2013 16:33'!
name: aName
	name := aName! !

Object subclass: #PlayerActionFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!PlayerActionFactory methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 18:50'!
create: params
	^self subclassResponsibility.! !

PlayerActionFactory subclass: #THPlayerActionFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!THPlayerActionFactory methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 18:49'!
create: params 

	| actionName |
	actionName := params at: 'actionType'.

	actionName = 'allin' ifTrue: [
		^AllIn new.
	].
	actionName = 'bet' ifTrue: [
		^Bet new amount: (params at: 'amount').
	].
	actionName = 'call' ifTrue: [
		^Call new.
	].
	actionName = 'check' ifTrue: [
		^Check new.
	].
	actionName = 'fold' ifTrue: [
		^Fold new.
	].
	actionName = 'raise' ifTrue: [
		^Raise new amount: (params at: 'amount').
	].

	"Should never reach this point"
	self error: 'Unknown Action Name: ' , actionName.! !

Object subclass: #PokerPlayerAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

PokerPlayerAction subclass: #AllIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!AllIn methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:00'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "actionType" :  "AllIn" }'.! !

PokerPlayerAction subclass: #Call
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Call methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:27'!
executeWith: aGame
	aGame call.! !

!Call methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:01'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "actionType" :  "Call" }'.! !

Call subclass: #Check
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Check methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:01'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "actionType" :  "Check" }'.! !

PokerPlayerAction subclass: #Fold
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Fold methodsFor: 'as yet unclassified' stamp: 'lb 7/22/2013 20:10'!
executeWith: aGame
	aGame fold.
	aGame activePlayers size = 1 ifTrue: [
		self halt. "is this where we want to do this... or in evaluate hands?"
		aGame nextPlayer.
		"refresh players to show last play"
		aGame UI = 'text' ifFalse: [
			aGame pokerTable refreshPlayerList: aGame players.
		].
	
		aGame setState: THEvaluateHands new.
	].! !

!Fold methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:01'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "actionType" :  "Fold" }'.! !

!PokerPlayerAction methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:27'!
executeWith: aGame
	^self subclassResponsibility! !

PokerPlayerAction subclass: #Raise
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

Raise subclass: #Bet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker'!

!Bet methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 21:20'!
amount
	^amount! !

!Bet methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/10/2013 21:19'!
amount: anAmount
	amount := anAmount.! !

!Bet methodsFor: 'as yet unclassified' stamp: 'lb 7/18/2013 00:48'!
jsonWriteOn: aWriteStream

	" quick and dirty to make something work for this class for now... "
	
	aWriteStream nextPutAll: '{ "actionType" :  "Bet" ,  "amount" : "'.
	aWriteStream nextPutAll: amount asString.
	aWriteStream nextPutAll: '" } '.! !

!Raise class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:29'!
newWith: anAmount
	| retVal |
	retVal := self new.
	retVal amount: anAmount.
	^retVal.! !

!Raise methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/17/2013 19:06'!
amount
	^amount.! !

!Raise methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:29'!
amount: anAmount
	amount := anAmount.! !

!Raise methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/16/2013 16:29'!
executeWith: aGame
	aGame raise: amount.! !

!Raise methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:02'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "actionType" :  "Raise" ,  "amount" : "'.
	aWriteStream nextPutAll: amount asString.
	aWriteStream nextPutAll: '" } '.! !

!Raise methodsFor: 'as yet unclassified' stamp: 'lb 7/22/2013 18:45'!
printString 
	^ (super printString), ': ', amount asString.! !

Object subclass: #Shuffler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

Shuffler subclass: #FisherYates
	instanceVariableNames: 'randomizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!FisherYates methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 20:26'!
initialize
	randomizer := Random new.! !

!FisherYates methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 21:42'!
shuffle: deck
	"Shuffles a deck of cards using the Fisher-Yates method"
	| remaining randIndex |
	remaining := deck size.
	
	[remaining > 1]
		whileTrue: [
			randIndex := randomizer nextInt: remaining.
			deck swap: randIndex with: remaining.
			remaining := remaining - 1.
		].! !

Shuffler subclass: #Mongean
	instanceVariableNames: 'randomizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Mongean methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 20:26'!
initialize
	randomizer := Random new.! !

!Mongean methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 21:15'!
shuffle: deck
	"Shuffles a deck of cards using the Mongean method 3 to 10 times"
	| numShuffles tempDeck |
	
	numShuffles := 2 + (randomizer nextInt: 8).
	
	[numShuffles > 0]
		whileTrue: [
			tempDeck := OrderedCollection new.
			
			[deck size > 1]
				whileTrue: [
					tempDeck addFirst: (deck draw).
					tempDeck addLast: (deck draw).
				].
			
			(deck size = 1) 
				ifTrue: [ 
					tempDeck add: (deck draw)
				].
			
			deck setDeckTo: tempDeck.
			numShuffles := numShuffles - 1.
		].! !

Shuffler subclass: #Riffle
	instanceVariableNames: 'randomizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

!Riffle methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 20:26'!
initialize
	randomizer := Random new.! !

!Riffle methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 20:53'!
shuffle: deck
	"Shuffles a deck of cards using the Riffle method 3 to 10 times"
	| numShuffles tempDeck splitIndex riffleIndex |
	
	numShuffles := 2 + (randomizer nextInt: 8).
	splitIndex := (deck size) / 2.
	
	[numShuffles > 0]
		whileTrue: [
			tempDeck := OrderedCollection new.
			riffleIndex := 1.
			
			[riffleIndex <= splitIndex] 
				whileTrue: [
					tempDeck add: (deck at: riffleIndex).
					tempDeck add: (deck at: (splitIndex + riffleIndex)).
					riffleIndex := riffleIndex + 1.
				].
			
			splitIndex even 
				ifFalse: [ 
					tempDeck add: (deck at: (splitIndex + 1)) 
				]. 
			
			deck setDeckTo: tempDeck.
			numShuffles := numShuffles - 1.
		].! !

!Shuffler methodsFor: 'as yet unclassified' stamp: 'EricSteele 7/6/2013 00:07'!
shuffle: deck
	"Shuffles a deck of cards"
	^self subclassResponsibility! !

Object subclass: #Suit
	instanceVariableNames: 'label value shortLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Poker-Cards'!

Suit class
	instanceVariableNames: 'suits'!

Suit class
	instanceVariableNames: 'suits'!

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:12'!
all
	^suits! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:06'!
clubs
	suits = nil ifTrue: [ self initialize ].
	^ suits at: #Clubs! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:07'!
diamonds
	suits = nil ifTrue: [ self initialize ].
	^ suits at: #Diamonds! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:07'!
hearts
	suits = nil ifTrue: [ self initialize ].
	^ suits at: #Hearts! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:07'!
initialize
	suits := Dictionary new.
	suits at: #Spades put: (Suit newWithLabel: #Spades value: 4 short: 'S').
	suits at: #Diamonds put: (Suit newWithLabel: #Diamonds value: 3 short: 'D').
	suits at: #Hearts put: (Suit newWithLabel: #Hearts value: 2 short: 'H').
	suits at: #Clubs put: (Suit newWithLabel: #Clubs value: 1 short: 'C').! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:07'!
newWithLabel: aLabel value: aValue
	^Suit new label: aLabel value: aValue! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:06'!
newWithLabel: aLabel value: aValue short: aShortLabel
	^Suit new label: aLabel value: aValue short: aShortLabel! !

!Suit class methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:11'!
spades
	suits = nil ifTrue: [ self initialize ].
	^ suits at: #Spades! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:08'!
label
	^label! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:08'!
label: aLabel
	label := aLabel.! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:08'!
label: aLabel value: aValue
	label := aLabel.
	value := aValue! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:06'!
label: aLabel value: aValue short: aShortLabel
	label := aLabel.
	value := aValue.
	shortLabel := aShortLabel.! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:09'!
printOn: aStream
	aStream nextPutAll: label;
		nextPutAll: ' (Suit)'.
	^aStream! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/12/2013 00:08'!
short
	^shortLabel! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:08'!
value
	^value! !

!Suit methodsFor: 'as yet unclassified' stamp: 'PeterIngulli 7/4/2013 11:08'!
value: aValue
	value := aValue! !
PokerPlayer initialize!
CardValue initialize!
Suit initialize!
